// Code generated by mockery v2.10.2. DO NOT EDIT.

package mocks

import (
	context "context"
	"sync"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/nikita.morozov/amqp-lib/v2/models"
)

// AcAmqp is an autogenerated mock type for the AcAmqp type
type AcAmqp struct {
	mock.Mock
	Mu sync.Mutex
	Wg sync.WaitGroup
}

// CloseConnection provides a mock function with given fields:
func (_m *AcAmqp) CloseConnection() {
	_m.Called()
}

// Publish provides a mock function with given fields: ctx, data, payload
func (_m *AcAmqp) Publish(ctx context.Context, data models.AmqpPublishData, payload interface{}) error {
	_m.Wg.Add(1)
	defer _m.Wg.Done()
	ret := _m.Called(ctx, data, payload)
	_m.Mu.Lock()

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, models.AmqpPublishData, interface{}) error); ok {
		r0 = rf(ctx, data, payload)
	} else {
		r0 = ret.Error(0)
	}

	_m.Mu.Unlock()
	return r0
}

// Subscribe provides a mock function with given fields: ctx, data, queue, handler
func (_m *AcAmqp) Subscribe(ctx context.Context, data models.AmqpPublishData, queue string, handler func([]byte)) {
	_m.Called(ctx, data, queue, handler)
}
